/****************************  FUEGOC.C  **********************************/
/*   Rubn Franco Molina. */

#include <math.h>
#include <stdio.h>
#include <conio.h>
#include <alloc.h>
#include <dos.h>
#include <stdlib.h>

int tabla[200];


void inicializa (void)
{
   int i;
   for (i=0; i<200; i++)
      tabla[i]=i*320;
}

void put_pixel(int x, int y, char color, unsigned donde)
{
   asm {
    mov cx, [x]
    mov bx, [y]
    cmp cx, 320
    ja fin
    cmp bx, 200
    ja fin
    mov ax, [donde]
    mov es, ax
    shl bx, 1
    push di
    mov di, word ptr [tabla + bx]
    add di, cx
    mov al, color
    stosb
    pop di
   }
fin: ;
}

void modo (char modo)
{
   asm {
    mov al, [modo]
    mov ah,0
    int 10h
    }
}

void flip ( unsigned donde)
{
   asm {
    mov ax,0A000h
    mov es,ax
    push ds
    push di
    push si
    mov ax, [donde]
    mov ds, ax
    xor di,di
    xor si,si
    mov cx, 16000
//    mov dx, 3DAh  }
//a1:
//    asm{
//    in al, dx
//    test al, 08h
//    jnz a1 }
//b2:
//    asm{
//    in al, dx
//    test al, 08h
//    jz b2
    db 66h
    rep movsw
    pop si
    pop di
    pop ds
   }
}

void fuego( unsigned donde)
{
   asm {
    push di
    mov ax, [donde]
    mov es, ax
    xor ax,ax
    xor di,di
    mov cx, 64000-319
    }
bucle:
    asm {
      mov al, es:[di]
      add al, es:[di+1]
      adc ah,0
      add al, es:[di-1]
      adc ah,0
      add al, es:[di+320]
      adc ah,0
      shr ax, 2
      jz cero
      dec al
      }
cero:
       asm {
      stosb
      xor ax,ax
     dec cx
     jnz bucle
    pop di
   }
}


void remapea_color ( char color, char r, char g, char b)
{
   asm{
   mov dx, 3C8h
   mov al, color
   out dx, al
   inc dx
   mov al, r
   out dx, al
   mov al, g
   out dx, al
   mov al, b
   out dx, al
   }
}

void cls ( unsigned donde)
{
   asm {
    push di
    mov ax, donde
    mov es, ax
    xor di,di
    db 66h
    xor ax, ax
    mov cx, 16000
    db 66h
    rep stosw
    pop di
   }
}

void circulo (int x, int y, int radio, char color, unsigned seg)
{
   double alfa;
   for ( alfa=0; alfa<6.283; alfa+=0.05)
     put_pixel(x+(radio*cos(alfa)),y+(radio*sin(alfa)),color,seg);
}


int main (void)
{
   int i,frames=0, x, y;
   char far *pantalla;
   unsigned segmento, inicio, fin, far *time=(unsigned far *)0x0040006C;
   if ((pantalla=(char far *)farmalloc(64000))==NULL) {
      printf("No hay memeoria para crear la pantalla virtual.\n");
      return 1;
      }
   printf(" \n%p", pantalla);
   inicializa();
   segmento=FP_SEG(pantalla);
   modo(0x13);
   for(i=1; i<128; i++)  remapea_color(i,i/2,0,0);
   for (i=128;i<256;i++) remapea_color(i,63,i/2,0);
   cls(segmento);
   flip(segmento);
   inicio=*time;
   while(!kbhit()) {
      x = (int)(cos(frames/13.0)*68.0);
      y = (int)(sin(frames/23.0)*66.0);
      circulo(160+x,100+y,10,255,segmento);
      circulo(160+y,100+x,20,255,segmento);
      fuego(segmento);
      flip(segmento); frames++;
      }
   fin=*time;
   modo(3);
   printf("%f frames por segundo.",18.2*frames/(fin-inicio));
   printf("\n Programado por Ruben Franco Molina. rufm@hotmail.com\n"
	  " Visita mi pagina sobre programacion grafica en http://members.tripod.com/~Rubenfm/index.html\n");
   farfree(pantalla);
   return 0;
}
